<script context="module">
    export const prerender = true
</script>

<script lang="ts">
    import { onMount } from 'svelte'
    import zxcvbn, { ZXCVBNResult } from 'zxcvbn'
    import { register } from '$lib/auth'
    import { get } from '$lib/fetch'
    import defaultInputs from '$lib/defaultPasswordInputs'
    import Authentication from '$components/Layouts/Authentication.svelte'
    import Input from '$components/Form/Input.svelte'
    import PasswordMeter from '$components/PasswordMeter.svelte'
    import Alert from '$components/Alert.svelte'

    let email = ''
    let username = ''
    let password = ''
    let errors = { email: [], username: [], password: [] }
    let open: { open: boolean; reason?: string } = { open: true }

    let passwordInputs: string[]
    $: passwordInputs = [...defaultInputs, email, username]

    let results: ZXCVBNResult
    $: results = zxcvbn(password, passwordInputs)

    const submit = () => {
        if (results.score < 2) return

        register(username, password, email).catch(({ errors: err }) => {
            errors = err
            if (err.closed) {
                open = err.closed
            }
        })
    }

    onMount(async () => {
        ;({ res: open } = await get('open-registrations'))
    })
</script>

<svelte:head>
    <title>Register | Elerium</title>
</svelte:head>

<Authentication
    btnLabel="Create my account"
    on:submit={submit}
    showSubmit={open.open}
    title="Hey! We're pleased you came!"
>
    {#if !open.open}
        <Alert variant="error">
            <h2 slot="title">Registrations are closed.</h2>
            <p>{open.reason}</p>
        </Alert>
    {:else}
        <Input bind:value={email} errors={errors.email} name="email" optional type="email"
            >Email</Input
        >
        <Input bind:value={username} errors={errors.username} name="username">Username</Input>
        <Input bind:value={password} errors={errors.password} name="password" type="password">
            Password
            <small slot="tooltip">
                <PasswordMeter {results} />
            </small>
        </Input>
    {/if}
    <slot slot="bottomUrl">
        I already have an account.
        <a href="login">Log in</a>
    </slot>
</Authentication>
